-------------------------
-- SinStats Configuration
-------------------------
local AddName, AddonTable = ...
local addVer = GetAddOnMetadata(AddName, "Version")
local byPass
local AceGUI = LibStub("AceGUI-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
--local AGSMW = LibStub("AceGUISharedMediaWidgets-1.0")

LSM:Register ("font", "Accidental Presidency", [[Interface\Addons\SinStats\fonts\Accidental Presidency.ttf]])
LSM:Register ("font", "Oswald", [[Interface\Addons\SinStats\fonts\Oswald-Regular.otf]])
LSM:Register ("font", "Nueva Std Cond", [[Interface\Addons\SinStats\fonts\NuevaStd-Cond.otf]])
LSM:Register ("font", "TrashHand", [[Interface\Addons\SinStats\fonts\TrashHand.TTF]])
LSM:Register ("font", "Harry P", [[Interface\Addons\SinStats\fonts\HARRYP__.TTF]])
LSM:Register ("font", "FORCED SQUARE", [[Interface\Addons\SinStats\fonts\FORCED SQUARE.ttf]])
LSM:Register("font", "Bazooka", [[Interface\Addons\SinStats\fonts\Bazooka.ttf]])
LSM:Register("font", "DorisPP", [[Interface\Addons\SinStats\fonts\DORISPP.ttf]])
LSM:Register("font", "Enigmatic", [[Interface\Addons\SinStats\fonts\Enigma__2.ttf]])
LSM:Register("font", "Liberation Sans (U)", [[Interface\Addons\SinStats\fonts\LiberationSans-Regular.ttf]])
LSM:Register("font", "Fira Mono", [[Interface\Addons\SinStats\fonts\FiraMono-Regular.ttf]])
LSM:Register("font", "Crystal", [[Interface\Addons\SinStats\fonts\CRYSRG__.ttf]])
LSM:Register("font", "White Rabbit", [[Interface\Addons\SinStats\fonts\WHITRABT.ttf]])
LSM:Register("font", "Monofonto", [[Interface\Addons\SinStats\fonts\MONOFONT.ttf]])
LSM:Register("font", "FSEX300 (U)", [[Interface\Addons\SinStats\fonts\FSEX300.ttf]])
LSM:Register("font", "DejaVu (U)", [[Interface\Addons\SinStats\fonts\DejaVuSansMono.ttf]])
LSM:Register("font", "Anonymous Pro Bold (U)", [[Interface\Addons\SinStats\fonts\AnonymousPro-Bold.ttf]])

AddonTable.Groups = { "Melee", "Ranged", "Spell", "Resistance", "Misc" }
OutlineStyle = {"OUTLINE", "THICKOUTLINE", "MONOCHROME", ""}

function AddonTable:UpdateStatus()
	SinStatsFrame:SetShown(not SinStatsDB.SinHideVar)
	local locked = SinStatsDB.SinLockVar
	SinStatsFrame:SetBackdropColor(1, 1, 1, locked and 0 or 1)
	SinStatsFrame:EnableMouse(not locked)
	SinStatsFrame.DragText:SetShown(not locked)
end

function AddonTable:ToggleEnable()
    if SinStatsConfigFrameTab1Enable then
        SinStatsConfigFrameTab1Enable:Click()
    else
        SinStatsDB.SinHideVar = not SinStatsDB.SinHideVar
        AddonTable:UpdateStatus()
    end
end

function AddonTable:ToggleLock()
    if SinStatsConfigFrameTab1Locked then
        SinStatsConfigFrameTab1Locked:Click()
    else
        SinStatsDB.SinLockVar = not SinStatsDB.SinLockVar
        AddonTable:UpdateStatus()
    end
end

local SinStatsConfig = CreateFrame("frame","SinStatsConfigFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
SinStatsConfig:SetMovable(true)
SinStatsConfig:SetClampedToScreen(true)
SinStatsConfig:SetUserPlaced(true)
SinStatsConfig:Hide()

function AddonTable:ToggleConfig()
	local Configs = {
		AP = { label=" Attack Power", tooltip=false, },
		APud = { label=" Attack Power [Undead]", tooltip="Displays the total attack power against an Undead NPC", },		
		RAP = { label=" Attack Power", tooltip=false, },
		RAPud = { label=" Attack Power [Undead]", tooltip="Displays the total attack power against an Undead NPC", },			
		DMG = { label=" Damage", tooltip=false, },
		RDMG = { label=" Damage", tooltip=false, },
		Fire = { label=" Fire Power", tooltip="Includes Fire damage from gear, consumables, enchants and talents", },		
		Frost = { label=" Frost Power", tooltip="Includes Frost damage from gear, consumables, enchants and talents", },		
		Arcane = { label=" Arcane Power", tooltip="Includes Arcane damage from gear, consumables, enchants and talents", },
		Shadow = { label=" Shadow Power", tooltip="Includes Shadow damage from gear, consumables, enchants and talents", },			
		Nature = { label=" Nature Power", tooltip="Includes Nature damage from gear, consumables, enchants and talents", },
		Healing = { label=" Healing Power", tooltip="Includes +healing from gear, consumables, enchants and talents", },
		Holy = { label=" Holy Power", tooltip="Includes Holy damage from gear, consumables, enchants and talents", },		
		spellUD = { label=" Undead Power", tooltip="Displays the spell damage against an Undead NPC, based on your highest spell damage", },				
		Crit = { label=" Critical Strike", tooltip=false, },    
		CritCap = { label=" Critical Cap", tooltip="Displays the Critical Strike Cap against a Raid Boss based on the weapons used and other character stats", },    		
		RangedCrit = { label=" Critical Strike", tooltip=false, },
		SpellCrit = { label=" Critical Strike", tooltip="Talent spell-specific Crit is colored\n(Grey = Priest's Holy Specialization)", },
		Hit = { label=" Hit", tooltip=false, },
		RangedHit = { label=" Hit", tooltip=false, },
		HasteMelee = { label=" Haste", tooltip="Haste bonus percentage from abilities procs, enchants,\ntalents, trinkets, consumables, buffs and world buffs", },
		weaponSpeed = { label=" Attack Speed", tooltip="Weapon speed for Main Hand and Off Hand", },
		MeleeMiss = { label=" Miss Chance", tooltip="Melee miss chance against NPC of the same level", },
		MeleeBoss = { label=" Miss vs Boss", tooltip="Melee miss chance against NPC of +3 levels", },
		HasteRanged = {  label=" Haste", tooltip="Haste bonus percentage from abilities procs, enchants\ntalents, trinkets, consumables, buffs and world buffs", },
		rangedSpeed = {  label=" Attack Speed", tooltip="Weapon speed of the equipped range weapon", },		
		RangedMiss = { label=" Miss Chance", tooltip="Ranged miss chance against NPC of the same level", },
		RangedBoss = { label=" Miss vs Boss", tooltip="Ranged miss chance against NPC of +3 levels", },
		SpellHit = { label=" Hit", tooltip="Talent spell-specific Hit is colored\n(Blue = Mage's Arcane Focus, Purple = Priest's Shadow Focus)", },
		HasteCaster = { label=" Haste", tooltip="Haste bonus percentage from abilities procs,\ntalents, trinkets, consumables, buffs and world buffs", },
		SpellMiss = { label=" Miss Chance", tooltip="Spell miss chance against NPC of the same level", },
		SpellBoss = { label=" Miss vs Boss", tooltip="Spell miss chance against NPC of +3 levels", },
		ManaRegen = { label=" Mana Regen", tooltip="Mana Regen per tick while not casting", },
		CastingRegen = { label=" Casting Regen", tooltip="Mana Regen per tick while casting", },
		MP5Cast = { label=" MP5", tooltip="MP5 value from gear, enchants, consumables and world buffs", },
		Armor = { label=" Armor", tooltip=false, },
		DMGReduc = { label=" Mitigation", tooltip="Percentage of damage reduction against NPC of the same level" , },
		Defense = { label=" Defense", tooltip=false, },
		Dodge = { label=" Dodge", tooltip=false, },
		Parry = { label=" Parry", tooltip=false, },
		Block = { label=" Block", tooltip=false, },
		FireResist = { label=" Fire", tooltip=false, },
		FrostResist = { label=" Frost", tooltip=false, },
		ShadowResist = { label=" Shadow", tooltip=false, },
		ArcaneResist = { label=" Arcane", tooltip=false, },		
		NatureResist = { label=" Nature", tooltip=false, },
		Speed = { label=" Movement Speed", tooltip=false, },
		Durability = { label=" Durability", tooltip=false, },
		Lag = { label=" Latency [ms]", tooltip=false, },
		FPS = { label=" Framerate [FPS]", tooltip=false, },
		Money = { label=" Money", tooltip=false, },		
	}
	for i= 1, #AddonTable.DisplayOrder do
		if not 	Configs[AddonTable.DisplayOrder[i].hud] then
			print("|cffff0000SinStats: MISSING Config entry << ".. AddonTable.DisplayOrder[i].hud.." >>|r")
		end
	end
	
	------------------------------------------------
	-- Factory functions for creating check boxes --
	------------------------------------------------
	local function OnEnter(self)
		local parent = self.tooltip and self or self:GetParent()
		GameTooltip:SetOwner(parent, "ANCHOR_LEFT")
		GameTooltip:SetText(parent.tooltip)
	end

	local function OnLeave()
		GameTooltip:Hide()
	end

local function CreateCheckBox(parent, name, label, key, entry, tooltip)
        local f = CreateFrame("CheckButton", "$parent"..name, parent, "UICheckButtonTemplate")
        f:SetSize(20, 20)
        f.LabelButton = CreateFrame("Button", "$parentButton", f)
        f.LabelButton:SetHighlightTexture("Interface/QuestFrame/UI-QuestTitleHighlight")
        f.LabelButton:GetHighlightTexture():SetBlendMode("ADD")
        f.LabelButton:SetPoint("LEFT", f, "RIGHT", 5, 0)
        f.LabelButton:SetScript("OnClick", function(self)
            self:GetParent():Click()
        end)
        f.Label = f:CreateFontString("$parentLabel", "OVERLAY")
        f.Label:SetFontObject(GameFontNormal)
        f.Label:SetJustifyV("CENTER")
        f.Label:SetTextColor(1, 1, 1, 1)
        f.Label:SetPoint("LEFT", f.LabelButton)
        local w, h = f.Label:GetSize()
        f.LabelButton:SetSize(w+5, h)
        f.key = key
        f.entry = entry
        f:SetChecked(key[entry])
        f:SetScript("OnClick", function(self)
            self.key[self.entry] = self:GetChecked()
            if not self.ignoreUpdate then
                SinStatsFrame.Stats[self.entry]:SetShown(self:GetChecked())
            end
            SinStatsFrame:ResizeStats()
            SinStatsFrame:RedrawStats()
            PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON)
        end)
        f:SetScript("OnDisable", function(self)
            self.Label:SetAlpha(0.5)
        end)
        f:SetScript("OnEnable", function(self)
            self.Label:SetAlpha(1)
        end)
        function f:SetText(text)
            self.Label:SetText(text)
            self.LabelButton:SetSize(self.Label:GetSize())
        end
        f:SetText(label)
        if tooltip then
            f.tooltip = tooltip
            f:SetScript("OnEnter",  OnEnter)
            f:SetScript("OnLeave",  OnLeave)
            f.LabelButton:SetScript("OnEnter",  OnEnter)
            f.LabelButton:SetScript("OnLeave",  OnLeave)
        end
        return f
    end

	----------------------------------------------------
	-- Factory functions for creating sheets and tabs --
	----------------------------------------------------
	local function TabOnClick(self) 
		PlaySound(SOUNDKIT.IG_CHARACTER_INFO_TAB)
		local ID = self:GetID()
		self:SetAlpha(1)
		self.widgets:Show()
		local parent = self:GetParent()
		for i=1, #parent.Tabs do
			if i ~= ID then
				parent.Tabs[i]:SetAlpha(0.5)
				parent.Tabs[i].widgets:Hide()
			end
		end
	end
     
	local function CreateTab(id, parent, text)
		local f = CreateFrame("Button", "$parentTab"..id, parent, "ConfigCategoryButtonTemplate")
		f:Hide()
		tinsert(parent.Tabs, f)
		f:SetID(id)
		f:SetText(text)
		local Text = _G[f:GetName().."NormalText"]
		Text:ClearAllPoints()
		Text:SetAllPoints()
		Text:SetJustifyH("CENTER")
		local width = parent:GetWidth() - 20
		f:SetSize(width / 6, Text:GetHeight() + 10)
		f:SetHighlightTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
		if id == 1 then
			f:SetPoint("TOPLEFT",parent,"TOPLEFT", 0, 0)
		else
			f:SetPoint("LEFT",parent.Tabs[id-1],"RIGHT", 0, 0)
		end
		f.widgets = CreateFrame("Frame", nil, f)
		f.widgets:Hide()
		f.widgets:SetSize(parent:GetWidth(), parent:GetHeight() - f:GetHeight()) 
		f.widgets:SetPoint("TOPLEFT", parent.Tabs[1], "BOTTOMLEFT")
		f:SetScript("OnClick", TabOnClick)
		f:Show()
		return f
	end

	---------------------------------------
	-- Factory functions for other stuff --
	---------------------------------------
	local function CreateSheetLabel(parent, text)
		local f = parent:CreateFontString("$parentLabel", "OVERLAY");
		f:SetFontObject("GameFontHighlight");
		f:SetText(text)
		return f
	end

	local function AddCheckBoxes(sheet, group, colwidth, rowoffset, coloffset)
        local Entries = {}
        sheet.CheckBoxes = {}
        for i=1, #AddonTable.DisplayOrder do
            if AddonTable.DisplayOrder[i].grp == group then
                tinsert(Entries, i)
            end
        end
        local row = rowoffset
        local col = coloffset
        local colcount = 1
        local rowmax = math.floor(#Entries/3)
        local over = mod(#Entries, 3)
        local rowcount = 0
        for i=1, #Entries do 
            local Settings = AddonTable.DisplayOrder[Entries[i]]
            local ConfigSettings = Configs[Settings.hud]
            local f = CreateCheckBox(sheet, Settings.hud, Settings.icon..ConfigSettings.label, SinStatsDB.Stats, Settings.hud, ConfigSettings.tooltip)
            tinsert(sheet.CheckBoxes, f)
            f:SetPoint("TOPLEFT", sheet, col, row)
            rowcount = rowcount + 1
            if ((over > 0 and colcount <= over) and rowcount == rowmax+1) or (colcount > over and rowcount == rowmax) then
                colcount = colcount + 1
                col = col + colwidth
                row = rowoffset
                rowcount = 0
            else
                row = row - 25
            end
        end
    end

	-------------------------------------------
	-- Hide/Show or Create the config. frame --
	-------------------------------------------
	if SinStatsConfig.Init then
		SinStatsConfig:SetShown(not SinStatsConfig:IsShown())
		return
	end
	local f = SinStatsConfig
	f.Init = true
	f:Show()
	f:SetBackdrop({
		bgFile="Interface/DialogFrame/UI-DialogBox-Background-Dark",
		edgeFile="Interface/DialogFrame/UI-DialogBox-Background-Dark",
		tile=1, tileSize=0, edgeSize=5,
	 })
	f:SetBackdropColor(1,1,1,1)
	f:SetWidth(635)
	f:SetHeight(390)
	f:ClearAllPoints()
	f:SetPoint("CENTER",UIParent)
	f:EnableMouse(true)
	f:RegisterForDrag("LeftButton")
	f:SetScript("OnDragStart", function(self) self:StartMoving() end)
	f:SetScript("OnDragStart", function(self) self:StartMoving() end)
	f:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	f:SetFrameStrata("FULLSCREEN_DIALOG")
	tinsert(UISpecialFrames, "SinStatsConfigFrame")
	f.Close = CreateFrame('Button', '$parentClose', f, "UIPanelCloseButton")
	f.Close:SetPoint('TOPRIGHT', 0,0)
	f.Close:SetSize(25, 25)
	f.Close:SetScript('OnClick', function(self)
		self:GetParent():Hide()
	end)
	
	f.Title = f:CreateFontString(nil, "OVERLAY");
	f.Title:SetFontObject("GameFontHighlight");
	f.Title:SetPoint("TOP", SinStatsConfig, "TOP", 0, -5);
	f.Title:SetText("|cff00f26dSinStats :|r |cffF0851AClassic|r");		

	local TabSettings = SinStatsDB.Stats
 	f.Tabs = {}
	local tab = CreateTab(1, f, "HUD") 
	tab:ClearAllPoints() 
	tab:SetPoint("TOPLEFT", 10, -40)
	local sheet = tab.widgets
	local colWidth = (sheet:GetWidth()-10)/3
	local colOffset = 35
	local rowOffset = -60
	
	sheet.SubSettings = CreateSheetLabel(sheet, "|cff00f26d" .. "General Options" .. "|r");	
	sheet.SubSettings.ignoreUpdate = true
	sheet.SubSettings:SetFontObject("GameFontHighlight");
	sheet.SubSettings:SetPoint('TOPLEFT', 105, -50)	
	
	sheet.SndSubSettings = CreateSheetLabel(sheet, "|cff00f26d" .. "Stats Text Options" .. "|r");	
	sheet.SndSubSettings.ignoreUpdate = true
	sheet.SndSubSettings:SetFontObject("GameFontHighlight");
	sheet.SndSubSettings:SetPoint('LEFT', 105, 35)	
	
	local l = sheet:CreateLine()
	l:SetColorTexture(1,0.49,0.04,0.5)
	l:SetStartPoint("LEFT",104,118)
	l:SetEndPoint("RIGHT",-90,118)
	l:SetThickness(1)
	l:Show()
	
	local sndl = sheet:CreateLine()
	sndl:SetColorTexture(1,0.49,0.04,0.5)
	sndl:SetStartPoint("LEFT",104,27)
	sndl:SetEndPoint("RIGHT",-90,27)
	sndl:SetThickness(1)
	sndl:Show()
	
	sheet.Reset = CreateFrame('Button', '$parentReset', sheet, "UIMenuButtonStretchTemplate")
	sheet.Reset:SetSize(60, 40)
	sheet.Reset:SetText("Reset \nPosition")
	sheet.Reset:SetPoint("BOTTOMLEFT", -6, 43)
	sheet.Reset:SetScript('OnClick', function(self)
		StaticPopup_Show("SINSTATS_HUD_RESET")
	end)	
	
	sheet.SigVer = CreateSheetLabel(sheet, "|cff00f26d" .. addVer .. "|r");	
	sheet.SigVer.ignoreUpdate = true
	sheet.SigVer:SetFontObject("GameFontHighlightSmall");	
	sheet.SigVer:SetPoint('BOTTOMRIGHT', -15, 43);				

	sheet.Label = CreateSheetLabel(sheet, "|cffF0851AHUD Settings|r")
	sheet.Label:SetPoint("TOP", sheet, "TOP", 0, -20);	

	------------------
	-- Enable Frame --
	------------------	
	sheet.Enable = CreateCheckBox(sheet, "Enable", "", SinStatsDB, "SinHideVar", "Enable/Disable the stats frame\nThis option can also be performed by Right-Clicking on the Minimap Button")
	sheet.Enable.ignoreUpdate = true
	sheet.Enable:SetPoint('TOPLEFT', 105, -73)
	sheet.Enable:HookScript('OnClick', function(self)
	        local Setting = self.key[self.entry]
		self:SetText(Setting and "HUD [|cffd4080cDisabled|r]" or "HUD [|cff00f26dEnabled|r]")
		AddonTable:UpdateStatus()
		self:GetParent().Locked:SetEnabled(not Setting)
	end)

	----------------
	-- Lock frame --
	----------------	
	sheet.Locked = CreateCheckBox(sheet, "Locked", "", SinStatsDB, "SinLockVar", "Locks/Unlocks the Stats frame to move it\nThis option can also be performed by Shift + Right-Clicking on the Minimap Button")
	sheet.Locked.ignoreUpdate = true
 	sheet.Locked:SetPoint('TOP', 50, -73)
 	sheet.Locked:HookScript('OnClick', function(self)
		local Locked = self.key[self.entry]
         	self:SetText(Locked and "HUD [|cffd4080cLocked|r]" or "HUD [|cff00f26dUnlocked|r]")
         	AddonTable:UpdateStatus()
	end)
	sheet.Locked:GetScript('OnClick')(sheet.Locked)
	sheet.Enable:GetScript('OnClick')(sheet.Enable)

	--------------------
	-- Minimap button --
	--------------------	
	sheet.mmToggle = CreateCheckBox(sheet, "mmToggle", "", SinStatsDB.minimap, "hide", "Toggle the minimap button")
	sheet.mmToggle:SetPoint("TOP", sheet.Enable, "BOTTOM", 0, -5);
	sheet.mmToggle.ignoreUpdate = true		
	if SinStatsDB.minimap.hide then
		byPass = true
	else	
		byPass = false
	end
	sheet.mmToggle:SetScript("OnClick", function(self)
    self.key[self.entry] = not self:GetChecked()
    local mmHide = self.key[self.entry]
    self:SetText(mmHide and "Minimap Button [|cffC41E3ADisabled|r]" or "Minimap Button [|cff00f26dEnabled|r]")
    if SinStatsDB.minimap.hide and byPass then
		AddonTable.sshMiniButton:Hide("SinStats") 
	elseif SinStatsDB.minimap.hide and not byPass then
		LibDBIcon10_SinStats:Hide()
    elseif not SinStatsDB.minimap.hide and byPass then
		AddonTable.sshMiniButton:Show("SinStats") 
	elseif not SinStatsDB.minimap.hide and not byPass then		
		LibDBIcon10_SinStats:Show()
    end
	end)          
	sheet.mmToggle:SetChecked(not SinStatsDB.minimap.hide)
	sheet.mmToggle:GetScript('OnClick')(sheet.mmToggle)		

	----------------
	-- Stat Icons --
	----------------	
	sheet.Icons = CreateCheckBox(sheet, "Icons", "", SinStatsDB, "IconVar", "Toggles the icons on the HUD")
	sheet.Icons.ignoreUpdate = true
 	sheet.Icons:SetPoint('TOP', sheet.Locked, 'BOTTOM', 0, -5)
	sheet.Icons:HookScript("OnClick", function(self)
		self:SetText(self.key[self.entry] and "Stats Icons [|cff00f26dEnabled|r]" or "Stats Icons [|cffd4080cDisabled|r]")
		SinStatsFrame.AddIcons = self.key[self.entry]
		AddonTable:RunAllEvents()
		SinStatsFrame:GetScript("OnUpdate")(SinStatsFrame, 5)
	end)		
	sheet.Icons:GetScript('OnClick')(sheet.Icons)	

	-------------------
	-- Font Selector --
	-------------------
	local fontSelector = AceGUI:Create("Dropdown")
	local LSMList = LSM:List("font")
	fontSelector:SetList(LSMList)
	 
	fontSelector:SetCallback("OnValueChanged", function(widget, event, key, ...)
		SinStatsDB.FontName = LSMList[key] -- Store the key to initalise the list next time
		SinStatsDB.StatFonts = LSM:Fetch("font", SinStatsDB.FontName) -- Store the font for SetFont
		SinStatsFrame:ResizeStats()  
		AddonTable:RunAllEvents()		
	end)
	
	for k, v in pairs(LSMList) do
		if v == SinStatsDB.FontName then
			fontSelector:SetValue(k)
			break
		end
	end

	fontSelector:SetLabel("|cffFFFFFFChange Fonts|r")
	fontSelector:SetWidth(150)
	fontSelector.frame:SetParent(sheet)
	fontSelector.frame:SetPoint("LEFT", 110, 0)
	
	------------------
	-- Text Outline --
	------------------
	local textOuline = AceGUI:Create("Dropdown")
	textOuline:SetList({
	"Thin", "Thick", "Monochrome", "None"
	})
	textOuline:SetCallback("OnValueChanged", function(widget, event, key)
		SinStatsDB.OutlineKey = key
		SinStatsDB.OutlineText = OutlineStyle[key]
		SinStatsFrame:ResizeStats()
		AddonTable:RunAllEvents()		
		--SinStatsFrame:RedrawStats()
    end)
    textOuline:SetValue(SinStatsDB.OutlineKey)
    textOuline:SetLabel("|cffFFFFFFText Outline|r")
	textOuline:SetWidth(125)
    textOuline.frame:SetParent(sheet)
	textOuline.frame:SetPoint("CENTER", 25, 0)
	
	---------------------
	-- Stats Alignment -- 
	---------------------
	local TextAlignment = AceGUI:Create("Dropdown")
	TextAlignment:SetList({
	"Left", "Right"
	})
	TextAlignment:SetCallback("OnValueChanged", function(widget, event, key)

	if SinStatsDB.TextIdentKey == 2 and SinStatsDB.SinDirection then
		SinStatsDB.TextIdentKey = 1
		SinStatsFrame:RedrawStats()
		AddonTable:RunAllEvents()
		TextAlignment:SetValue(SinStatsDB.TextIdentKey)
	else
		SinStatsDB.TextIdentKey = key
		SinStatsFrame:RedrawStats()
		AddonTable:RunAllEvents()		
	end
		
    end)
    TextAlignment:SetValue(SinStatsDB.TextIdentKey)
    TextAlignment:SetLabel("|cffFFFFFFStats Alignment|r")
	TextAlignment:SetWidth(125)
    TextAlignment.frame:SetParent(sheet)
	TextAlignment.frame:SetPoint("CENTER", 170, 0)	
	
	----------------
	-- Stat Order --
	----------------		
	local statsOrder = AceGUI:Create("Dropdown")
	statsOrder:SetList({
	"Default", "Tab"
	})
	statsOrder:SetCallback("OnValueChanged", function(widget, event, key)
		SinStatsDB.OrderKey = key
		if SinStatsDB.OrderKey == 1 then
			SinStatsDB.GroupOrder = false
		else
			SinStatsDB.GroupOrder = true
		end
		SinStatsFrame:RedrawStats()
    end)
    statsOrder:SetValue(SinStatsDB.OrderKey)
    statsOrder:SetLabel("|cffFFFFFFStats Grouping|r")
	statsOrder:SetWidth(125)
    statsOrder.frame:SetParent(sheet)
	statsOrder.frame:SetPoint("LEFT", 110, -50)		


	--------------------
	-- Text Alignment --
	--------------------	
	sheet.Direction = CreateCheckBox(sheet, "Direction", "", SinStatsDB, "SinDirection", "Changes the direction of the stats, between vertical and horizontal\nIf Horizontal is selected, you will have the option to set the\nnumber of stats displayed per row")
    sheet.Direction.ignoreUpdate = true
    sheet.Direction:SetPoint('TOP', sheet.Icons, 'BOTTOM', 65, -110)
    sheet.Direction:HookScript('OnClick', function(self)
        local Setting = self.key[self.entry]
        self:SetText(Setting and "Text Rows [|cffF2A427Horizontal|r]" or "Text Rows [|cff00f26dVertical|r]")
        SinStatsFrame:RedrawStats()
        self:GetParent().Rows:SetShown(self:GetChecked())
		self:GetParent().Spacing:SetShown(self:GetChecked())
		if Setting then
		SinStatsDB.TextIdentKey = 1
		TextAlignment:SetValue(SinStatsDB.TextIdentKey)
		SinStatsFrame:RedrawStats()
		AddonTable:RunAllEvents()
		end
    end)
    sheet.Direction:SetText(SinStatsDB.SinDirection and "Text Rows[|cffF2A427Horizontal|r]" or "Text Rows [|cff00f26dVertical|r]")

	---------------	
	-- Text Rows --
	---------------	
	sheet.Rows = CreateFrame("Slider", "SinStatsSlider", sheet, 'OptionsSliderTemplate')
    sheet.Rows:SetShown(SinStatsDB.SinDirection)
    sheet.Rows:SetPoint("TOPLEFT", sheet.Direction, "BOTTOMLEFT", 20, -30)
    sheet.Rows.Low:SetText('1'); 
    sheet.Rows.High:SetText('5');   
    sheet.Rows.Text:SetText('Stats Rows');
    sheet.Rows:SetMinMaxValues(1, 5)
    sheet.Rows:SetValueStep(1)
    sheet.Rows.key = SinStatsDB
    sheet.Rows.entry = "StatRows"
    sheet.Rows:SetValue(SinStatsDB.StatRows or 1)
    sheet.Rows.Label = sheet.Rows:CreateFontString(nil, "OVERLAY");
    sheet.Rows.Label:SetFontObject("GameFontHighlightSmall");
    sheet.Rows.Label:SetPoint("TOP", sheet.Rows, "BOTTOM", 3, 0);     
    sheet.Rows:SetScript("OnValueChanged", function (self)
        local value = math.floor(self:GetValue())
        self.key[self.entry] = value
        SinStatsFrame:RedrawStats()
        self.Label:SetText("Current: " .. self.key[self.entry])
    end)
    sheet.Rows:GetScript("OnValueChanged")(sheet.Rows)	

	----------------	
	-- Text Style --
	----------------	
	local textStyle = AceGUI:Create("Dropdown")
	textStyle:SetList({
	"Normal", "Short"
	})
	if (SinStatsDB.SinAbrev == false) then
		SinStatsDB.StyleKey = 1
	else
		SinStatsDB.StyleKey = 2
	end
	textStyle:SetCallback("OnValueChanged", function(widget, event, key)
		SinStatsDB.StyleKey = key
		if SinStatsDB.StyleKey == 1 then
			SinStatsDB.SinAbrev = false
		else
			SinStatsDB.SinAbrev = true
		end
		AddonTable:RunAllEvents()
    end)
    textStyle:SetValue(SinStatsDB.StyleKey)
    textStyle:SetLabel("|cffFFFFFFText Style|r")
	textStyle:SetWidth(125)
    textStyle.frame:SetParent(sheet)
	textStyle.frame:SetPoint("CENTER", 25, -50)
	
	------------------	
	-- Text Spacing --
	------------------
	sheet.Spacing = CreateFrame("Slider", "SinStatsSlider", sheet, 'OptionsSliderTemplate')
    sheet.Spacing:SetShown(SinStatsDB.SinDirection)	
	sheet.Spacing:SetPoint('TOP', sheet.Direction, 'BOTTOM', -85, -30)
	sheet.Spacing.Low:SetText('0'); 
	sheet.Spacing.High:SetText('60');   
	sheet.Spacing.Text:SetText("Text Spacing");
	sheet.Spacing:SetMinMaxValues(0, 60)
	sheet.Spacing:SetValueStep(1)
	sheet.Spacing.key = SinStatsDB
	sheet.Spacing.entry = "StatSpacing"
	sheet.Spacing:SetValue(SinStatsDB.StatSpacing or 7)
	sheet.Spacing.Label = sheet.Spacing:CreateFontString(nil, "OVERLAY");
	sheet.Spacing.Label:SetFontObject("GameFontHighlightSmall");
	sheet.Spacing.Label:SetPoint("TOP", sheet.Spacing, "BOTTOM", 0, -5);		
	sheet.Spacing:SetScript("OnValueChanged", function (self)
		local value = math.floor(self:GetValue())
		self.key[self.entry] = value
		SinStatsFrame:RedrawStats()
		SinStatsFrame:ResizeStats()
		AddonTable:RunAllEvents()	
		self.Label:SetText("Current: " .. self.key[self.entry])
	end)
	sheet.Spacing:GetScript("OnValueChanged")(sheet.Spacing)	

	---------------	
	-- Text Size --
	---------------
	sheet.Size = CreateFrame("Slider", "SinStatsSlider", sheet, 'OptionsSliderTemplate')
	sheet.Size:SetPoint('TOP', sheet.mmToggle, 'BOTTOM', 70, -160)
	sheet.Size.Low:SetText('8'); 
	sheet.Size.High:SetText('60');   
	sheet.Size.Text:SetText('Text Size');
	sheet.Size:SetMinMaxValues(8, 60)
	sheet.Size:SetValueStep(1)
	sheet.Size.key = SinStatsDB
	sheet.Size.entry = "StatFontSize"
	sheet.Size:SetValue(SinStatsDB.StatFontSize)
	sheet.Size.Label = sheet.Size:CreateFontString(nil, "OVERLAY");
	sheet.Size.Label:SetFontObject("GameFontHighlightSmall");
	sheet.Size.Label:SetPoint("TOP", sheet.Size, "BOTTOM", 0, -5);		
	sheet.Size:SetScript("OnValueChanged", function (self)
		local value = math.floor(self:GetValue())
		self.key[self.entry] = value
		SinStatsFrame:RedrawStats()
		SinStatsFrame:ResizeStats()		
		AddonTable:RunAllEvents()		
		self.Label:SetText("Current: " .. self.key[self.entry])
	end)
	sheet.Size:GetScript("OnValueChanged")(sheet.Size)

	for grp=1, #AddonTable.Groups do
		tab = CreateTab(grp+1, f, AddonTable.Groups[grp])
		sheet = tab.widgets 
		sheet.Label = CreateSheetLabel(sheet, "|cffF0851A"..AddonTable.Groups[grp].." Settings|r")
		sheet.Label:SetPoint("TOP", sheet, "TOP", 0, -30);
		AddCheckBoxes(sheet, grp, colWidth, rowOffset, colOffset)
		
		sheet.EnableAll = CreateFrame('Button', '$parentEnableAll', sheet, "UIMenuButtonStretchTemplate")
		sheet.EnableAll:SetSize(110, 25)
		sheet.EnableAll:SetText("Enable All Stats")
		sheet.EnableAll:SetPoint('BOTTOMLEFT', 0, 43)
		sheet.EnableAll:SetScript('OnClick', function(self)
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON)
		local Parent = self:GetParent()
			for k, v in ipairs(Parent.CheckBoxes) do
				v:SetChecked(true)
				v.key[v.entry] = true
				if not v.ignoreUpdate then
					SinStatsFrame.Stats[v.entry]:Show()
				end
			end
			SinStatsFrame:RedrawStats()
			SinStatsFrame:ResizeStats()		
			AddonTable:RunAllEvents()
		end)	
		
		sheet.DisableAll = CreateFrame('Button', '$parentDisableAll', sheet, "UIMenuButtonStretchTemplate")
		sheet.DisableAll:SetSize(110, 25)
		sheet.DisableAll:SetText("Disable All Stats")
		sheet.DisableAll:SetPoint('BOTTOMLEFT', 120, 43)
		sheet.DisableAll:SetScript('OnClick', function(self)
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON)
		local Parent = self:GetParent()
			for k, v in ipairs(Parent.CheckBoxes) do
				v:SetChecked(false)
				v.key[v.entry] = false
				if not v.ignoreUpdate then
					SinStatsFrame.Stats[v.entry]:Hide()
				end
			end
			SinStatsFrame:RedrawStats()
			SinStatsFrame:ResizeStats()		
			AddonTable:RunAllEvents()					
		end)
		
	end
	
	TabOnClick(f.Tabs[1])	
	
	--------------------------------------
	-- Factory function for break lines --
	--------------------------------------
	local function CreateOptionLine(parent)
		local f = parent:CreateLine()
			f:SetColorTexture(1,0.49,0.04,0.5)
			f:SetStartPoint("LEFT",120,136)
			f:SetEndPoint("RIGHT",-120,136)
			f:SetThickness(1)
			f:Show()
		return f
	end	
	
	sheet.OptionLine = CreateOptionLine(SinStatsConfigFrameTab2.widgets)
	sheet.OptionLine = CreateOptionLine(SinStatsConfigFrameTab3.widgets)
	sheet.OptionLine = CreateOptionLine(SinStatsConfigFrameTab4.widgets)
	sheet.OptionLine = CreateOptionLine(SinStatsConfigFrameTab5.widgets)

end

SinStatsOptions = {};

SinStatsOptions.panel = CreateFrame( "Frame", "SinStatsOptionsPanel", UIParent );
SinStatsOptions.panel.name = "SinStats";
InterfaceOptions_AddCategory(SinStatsOptions.panel);

local maintitle = SinStatsOptions.panel:CreateFontString("MainTitle", "OVERLAY", "GameFontHighlightLarge")
maintitle:SetPoint("TOP", "SinStatsOptionsPanel", "TOP", 0, -15)
maintitle:SetText("|cff00f26dSinStats|r")
maintitle:SetFont("Fonts\\FRIZQT__.TTF", 45)

local wowversion = SinStatsOptions.panel:CreateFontString("WowVersion", "OVERLAY", "GameFontHighlightLarge")
wowversion:SetPoint("TOP", "MainTitle", "BOTTOM", 0, -10)
wowversion:SetText("|cffF2A427Classic|r")
wowversion:SetFont("Fonts\\FRIZQT__.TTF", 30)

local OptionButton = CreateFrame('Button', '$parentSinStatsOptionsPanel', SinStatsOptionsPanel, "UIPanelButtonTemplate")
OptionButton:SetPoint("TOP", "WowVersion", "BOTTOM", 0, -40)
OptionButton:SetSize(160, 25)
OptionButton:SetText("|cffFFFFFFOpen SinStats Settings|r")
OptionButton:SetScript('OnClick', function(self)
	InterfaceOptionsFrame:Hide()
	HideUIPanel(GameMenuFrame)
	AddonTable:ToggleConfig()
end)

local tipText = SinStatsOptions.panel:CreateFontString("TipText", "OVERLAY", "GameFontHighlight")
tipText:SetPoint("TOP", "WowVersion", "BOTTOM", 0, -150)
tipText:SetText("|cffF2A427The settings panel can be accessed with the commands " .. "|cff00f26d/sinstats|r" .. " or " .. "|cff00f26d/ss|r")

local tipTextSnd = SinStatsOptions.panel:CreateFontString("TipTextSnd", "OVERLAY", "GameFontHighlight")
tipTextSnd:SetPoint("TOP", "TipText", "BOTTOM", 0, -3)
tipTextSnd:SetText("|cffF2A427The" .." |cff00f26dminimap button|r" .. " |cffF2A427can also be used to quickly access the settings.|r")

local VersionText = SinStatsOptions.panel:CreateFontString("VersionText", "OVERLAY", "GameFontHighlight")
VersionText:SetPoint("TOP", "TipTextSnd", "BOTTOM", 0, -70)
VersionText:SetText("|cffF2A427Version:|r " .. "|cff00f26d" .. addVer .. "|r")

local authorText = SinStatsOptions.panel:CreateFontString("authorText", "OVERLAY", "GameFontHighlight")
authorText:SetPoint("TOP", "VersionText", "BOTTOM", 0, -10)
authorText:SetText("|cffF2A427Author:|r |cff00f26dSinba|r")